jjb: use bundler in lttng-www
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
51c9c62d 1#!/bin/bash
f3d8604b 2#
51c9c62d 3# Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
51c9c62d
MJ
18set -exu
19
39961776 20# Parameters
2456f978 21arch=${arch:-amd64}
39961776
MJ
22cross_arch=${cross_arch:-}
23ktag=${ktag:-}
5a196804
MJ
24kgitrepo=${kgitrepo:-}
25mversion=${mversion:-}
26mgitrepo=${mgitrepo:-}
39961776
MJ
27
28
339db64d
MJ
29## FUNCTIONS ##
30
f3d8604b
MJ
31# Kernel version compare functions
32verlte() {
51fa2ab3 33 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
34}
35
36verlt() {
28b10e79 37 # shellcheck disable=SC2015
51fa2ab3 38 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
39}
40
41vergte() {
51fa2ab3 42 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
43}
44
45vergt() {
28b10e79 46 # shellcheck disable=SC2015
51fa2ab3 47 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
48}
49
339db64d 50
5a196804
MJ
51git_clone_modules_sources() {
52 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
53
54 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
55 # as a branch name.
56 if [ "${mversion:0:5}" = "refs/" ]; then
57 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
58 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
59 else
60 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
61 fi
5a196804
MJ
62}
63
64# Checkout a shallow kernel tree of the specified tag
65git_clone_linux_sources() {
66 mkdir -p "$LINUX_GIT_DIR"
67 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
68}
7e02032c 69
7e02032c 70
5a196804
MJ
71# Export the kernel sources from the git repo
72git_export_linux_sources() {
73 cd "$LINUX_GIT_DIR"
74 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
75}
76
77
78# Upload the tar archive to the object store
79upload_archive_obj() {
80 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
81 rm -f "$WORKSPACE/$obj_name"
82}
83
84
85extract_archive_obj() {
86 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
87 rm -f "$WORKSPACE/$obj_name"
88}
89
90
91tar_archive_obj() {
92 cd "$LINUX_OBJ_DIR"
93 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
94 cd -
95}
96
97# Find the most recent GCC version supported by the kernel sources
98select_compiler() {
99 local selected_cc
100
101 cd "$LINUX_SRCOBJ_DIR"
102
103 kversion=$(make -s kernelversion)
104
105 set +e
106
2456f978 107 for cc in gcc-8 gcc-5 gcc-4.8; do
5a196804
MJ
108 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
109 selected_cc="$cc"
110 break
111 fi
112 done
113
114 set -e
115
116 if [ "x$selected_cc" = "x" ]; then
117 echo "Found no suitable compiler."
118 exit 1
119 fi
120
1d5a0a3c
MJ
121 # Force gcc-4.8 for kernels before 3.18
122 if { verlt "$kversion" "3.18"; }; then
23db2292 123 selected_cc=gcc-4.8
7e02032c
MJ
124 fi
125
425e4992
MJ
126 if [ "$selected_cc" != "gcc-4.8" ]; then
127 # Older kernel Makefiles do not expect the compiler to default to PIE
128 KAFLAGS="-fno-pie"
c45b04df 129 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
130 KCPPFLAGS="-fno-pie"
131 export KAFLAGS KCFLAGS KCPPFLAGS
132 fi
133
5a196804 134 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 135 export HOSTCC="${selected_cc}"
5a196804
MJ
136
137 cd -
138}
139
140
141build_linux_kernel() {
142 cd "$LINUX_SRCOBJ_DIR"
143
144 kversion=$(make -s kernelversion)
145
7e02032c 146 # Generate kernel configuration
a1ae361e 147 case "$ktag" in
7e02032c 148 Ubuntu*)
39961776 149 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 150 if vergte "${kversion}" "4.10"; then
39961776
MJ
151 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
152 exit 0
153 fi
154 fi
af101606
MJ
155
156 # Disable riscv64 config generation, we don't have a toolchain on bionic
157 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
158
073dc82c
MJ
159 # Hack for kernel Ubuntu-hwe-5.8
160 if [ ! -f "debian/compat" ]; then
161 echo "10" > "debian/compat"
162 fi
163
a46abb0a
MJ
164 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
165 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 166 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 167 ;;
c45b04df 168
7e02032c 169 *)
16844a6d
MJ
170 # Force 32bit build on i386, default is 64bit
171 if [ "$arch" = "i386" ]; then
5a196804
MJ
172 export ARCH="i386"
173 fi
174
175 # allyesconfig is mostly broken for kernels of the 2.6 series
176 if verlt "$kversion" "3.0"; then
177 vanilla_config="defconfig"
7a76a4d0
MJ
178 fi
179
5a196804 180 make "${vanilla_config}"
7e02032c
MJ
181 ;;
182 esac
183
53b51a15 184 # oldnoconfig was renamed in 4.19
5a196804 185 if vergte "$kversion" "4.19"; then
53b51a15 186 update_conf_target="olddefconfig"
5a196804 187 else
53b51a15 188 update_conf_target="oldnoconfig"
5a196804
MJ
189 fi
190
191 # Fix 'defined(@array)' was removed from recent perl
192 if [ -f "kernel/timeconst.pl" ]; then
193 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
194 fi
195
196 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 197 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
198 if [ -f "arch/x86/kvm/svm.c" ]; then
199 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
200 fi
201
202 if [ -f "arch/x86/kvm/vmx.c" ]; then
203 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
204 fi
205 fi
206
53b51a15
MJ
207 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
208 # Convert them to 'cmpw' which was previously done silently
209 if verlt "$kversion" "4.9"; then
210 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
211 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
212 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
213 fi
214
5a196804
MJ
215 # Fix a typo in v2.6.36.x
216 if [ -f "arch/x86/kernel/entry_64.S" ]; then
217 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
218 fi
219
53b51a15
MJ
220 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
221 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
222 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
223 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
224 fi
225
5a196804
MJ
226 # Fix kernel < 3.0 with gcc >= 4.7
227 if verlt "$kversion" "3.0"; then
228 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
229 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
230 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
231 echo "header-y += linkage.h" >> include/linux/Kbuild
232 fi
233
7e02032c 234 # GCC 4.8
53b51a15
MJ
235 if [ "$HOSTCC" == "gcc-4.8" ]; then
236 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
237 fi
7e02032c
MJ
238
239 # Don't try to sign modules
53b51a15 240 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 241
9ef18fa2 242 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 243 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
244
245 # Cause problems with inline assembly on i386
53b51a15 246 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 247
1d5a0a3c 248 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
249 scripts/config --disable CONFIG_SAMPLES
250 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
251
252 # Disable kcov
53b51a15 253 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
254
255 # Broken on some RT kernels
53b51a15 256 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 257
1e300ea9 258 # Broken drivers
53b51a15
MJ
259 scripts/config --disable CONFIG_RAPIDIO_TSI721
260 scripts/config --disable CONFIG_SGI_XP
261 scripts/config --disable CONFIG_MFD_WM8994
262 scripts/config --disable CONFIG_DRM_RADEON
263 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 264
5a196804
MJ
265 # IGBVF won't build with recent gcc on 2.6.38.x
266 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 267 scripts/config --disable CONFIG_IGBVF
5a196804 268 fi
9ef18fa2 269
c72041eb
MJ
270 # Don't fail the build on warnings
271 scripts/config --disable CONFIG_WERROR
272
51fa2ab3 273 # Set required options
53b51a15
MJ
274 scripts/config --enable CONFIG_TRACEPOINTS
275 scripts/config --enable CONFIG_KALLSYMS
276 scripts/config --enable CONFIG_HIGH_RES_TIMERS
277 scripts/config --enable CONFIG_KPROBES
278 scripts/config --enable CONFIG_FTRACE
279 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
280 scripts/config --enable CONFIG_KALLSYMS_ALL
281 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
282 scripts/config --enable CONFIG_PERF_EVENTS
283 scripts/config --enable CONFIG_EVENT_TRACING
284 scripts/config --enable CONFIG_KRETPROBES
7e02032c 285
1d28ffce
MJ
286 # FIXME: disable objtool on vmlinux, it OOMs on allyesconfig
287 sed -i 's/objtool_link vmlinux.o//' scripts/link-vmlinux.sh || true
81e61c58
MJ
288 # Starting with v6.1-rc6
289 sed -i 's/^objtool-enabled := .*/objtool-enabled := /' scripts/Makefile.vmlinux_o || true
1d28ffce 290
7a76a4d0 291 # Debug
5a196804
MJ
292 #cat .config
293
294 make "$update_conf_target" CC="$CC"
295 make -j"$NPROC" CC="$CC"
296
c45b04df 297 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
298
299 # Save the kernel and modules
300 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15 301 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
f4c112e8 302 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
303 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
304 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
305 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
306}
307
308
309extract_distro_headers() {
310
311 # Enter linux source dir
312 cd "${LINUX_SRCOBJ_DIR}"
313
314
315 # For RT kernels, copy version file
316 if [ -s localversion-rt ]; then
317 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
318 fi
319
320 # Copy all Makefile related stuff
321 find . -path './include/*' -prune \
322 -o -path './scripts/*' -prune -o -type f \
323 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
324 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
325 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
326
327 # Copy base scripts and include dirs
328 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 329
5a196804
MJ
330 # Copy arch includes
331 (find arch -name include -type d -print0 | \
332 xargs -0 -n1 -i: find : -type f) | \
333 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
334
335 # Copy arch scripts
336 (find arch -name scripts -type d -print0 | \
337 xargs -0 -n1 -i: find : -type f) | \
338 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
339
340 # Cleanup scripts
341 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
342 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
343
04873cc3 344 # On powerpc 32bits this object is required to link modules
5a196804 345 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
346 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
347 :
348 else
04873cc3
MJ
349 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
350 fi
5a196804
MJ
351 fi
352
353 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
354 if [ "${karch}" = "arm64" ]; then
355 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
356 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
357 fi
358 fi
359
360 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
361 if [ -f tools/objtool/objtool ]; then
362 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
363 fi
364
365 if [ -f "arch/x86/kernel/macros.s" ]; then
366 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
367 fi
368
369 # Copy modules related stuff, if available
370 if [ -s Module.symvers ]; then
371 cp Module.symvers "${LINUX_HDROBJ_DIR}"
372 fi
373
374 if [ -s System.map ]; then
375 cp System.map "${LINUX_HDROBJ_DIR}"
376 fi
377
378 if [ -s Module.markers ]; then
379 cp Module.markers "${LINUX_HDROBJ_DIR}"
380 fi
381
382 # Copy config file
383 cp .config "${LINUX_HDROBJ_DIR}"
384
385 # Make sure the Makefile and version.h have a matching timestamp so that
386 # external modules can be built
387 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
388 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
389 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
390 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
391 else
392 echo "Missing version.h"
393 exit 1
394 fi
395 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
396
397 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
780f6285
MJ
398 if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
399 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
400 fi
5a196804
MJ
401
402 # Finally clean the object files from the full source tree
403 make clean
404
405 # And regen the modules support files
406 make modules_prepare CC="$CC"
51fa2ab3 407
04873cc3 408 # On powerpc 32bits this object is required to link modules
d815b018 409 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
410 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
411 :
412 else
04873cc3
MJ
413 make arch/powerpc/lib/crtsavres.o CC="$CC"
414 fi
d815b018
MJ
415 fi
416
7a76a4d0 417 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 418 if [ "${karch}" = "arm64" ]; then
c236528e 419 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 420 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
421 fi
422 fi
423
7e02032c 424 # Version specific tasks
a1ae361e 425 case "$ktag" in
7e02032c
MJ
426 Ubuntu*)
427 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 428 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
429 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
430 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
431 ;;
432 esac
7e02032c
MJ
433}
434
435
339db64d
MJ
436build_modules() {
437
5a196804
MJ
438 local kdir="$1"
439 local outdir="$2"
440 local kversion
441
442 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 443
2456f978
MJ
444 # Try to catch some compatibility problems by turning some
445 # warnings into errors.
999a2aa0 446 #export KCFLAGS="$KCFLAGS -Wall -Werror"
2456f978 447
339db64d 448 # Enter lttng-modules source dir
5a196804 449 cd "${MODULES_GIT_DIR}"
339db64d
MJ
450
451 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
452 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
453 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
454 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
455
456 set +e
457
458 # Build modules
51fa2ab3 459 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 460 ret=$?
339db64d 461
5a196804
MJ
462 set -e
463
339db64d 464 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 465 if [ "$ret" -eq 0 ]; then
e9b44189 466 echo "This build should have failed."
339db64d
MJ
467 exit 1
468 fi
469
470 # We have to publish at least one file or the build will fail
5a196804 471 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 472
5a196804 473 KERNELDIR="${kdir}" make clean
7e02032c 474
339db64d
MJ
475 else # Regular build
476
477 # Build modules against full kernel sources
51fa2ab3 478 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
479
480 # Install modules to build dir
5a196804 481 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
482
483 # Clean build dir
5a196804 484 KERNELDIR="${kdir}" make clean
339db64d
MJ
485 fi
486}
487
488
489## MAIN ##
490
f3d8604b
MJ
491# Use all CPU cores
492NPROC=$(nproc)
493
5a196804
MJ
494MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
495LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 496
5a196804
MJ
497LINUX_OBJ_DIR="${WORKSPACE}/linux"
498LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
499LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
500LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 501
5a196804
MJ
502MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
503MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 504
5a196804
MJ
505LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
506
507OBJ_STORE_URL="s3://jenkins"
508
509cd "$WORKSPACE"
510
511# Create build directories
512mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
513
514git_clone_modules_sources
339db64d 515
7e02032c 516# Setup cross compile env if available
39961776 517if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
518
519 case "$cross_arch" in
520 "armhf")
521 karch="arm"
522 cross_compile="arm-linux-gnueabihf-"
53b51a15 523 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
524 ubuntu_config="armhf-config.flavour.generic"
525 ;;
526
527 "arm64")
528 karch="arm64"
529 cross_compile="aarch64-linux-gnu-"
53b51a15 530 vanilla_config="defconfig"
7e02032c
MJ
531 ubuntu_config="arm64-config.flavour.generic"
532 ;;
533
534 "powerpc")
535 karch="powerpc"
536 cross_compile="powerpc-linux-gnu-"
e9b44189 537 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
538 ubuntu_config="powerpc-config.flavour.powerpc-smp"
539 ;;
540
541 "ppc64el")
542 karch="powerpc"
543 cross_compile="powerpc64le-linux-gnu-"
e9b44189 544 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
545 ubuntu_config="ppc64el-config.flavour.generic"
546 ;;
547
548 *)
51fa2ab3 549 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
550 exit 1
551 ;;
552 esac
339db64d 553
7e02032c
MJ
554 # Export variables used by Kbuild for cross compilation
555 export ARCH="${karch}"
556 export CROSS_COMPILE="${cross_compile}"
339db64d 557
7e02032c 558# Set arch specific values if we are not cross compiling
39961776 559elif [ "x${arch}" != "x" ]; then
e9b44189 560
7e02032c 561 case "$arch" in
16844a6d 562 "i386")
7e02032c 563 karch="x86"
e9b44189 564 vanilla_config="allyesconfig"
7e02032c
MJ
565 ubuntu_config="i386-config.flavour.generic"
566 ;;
567
16844a6d 568 "amd64")
7e02032c 569 karch="x86"
e9b44189 570 vanilla_config="allyesconfig"
7e02032c
MJ
571 ubuntu_config="amd64-config.flavour.generic"
572 ;;
573
574 "armhf")
575 karch="arm"
e9b44189 576 vanilla_config="allyesconfig"
7e02032c
MJ
577 ubuntu_config="armhf-config.flavour.generic"
578 ;;
579
580 "arm64")
581 karch="arm64"
e9b44189 582 vanilla_config="allyesconfig"
7e02032c
MJ
583 ubuntu_config="arm64-config.flavour.generic"
584 ;;
585
586 "powerpc")
587 karch="powerpc"
e9b44189 588 vanilla_config="allyesconfig"
7e02032c
MJ
589 ubuntu_config="powerpc-config.flavour.powerpc-smp"
590 ;;
591
592 "ppc64el")
593 karch="powerpc"
e9b44189 594 vanilla_config="allyesconfig"
7e02032c
MJ
595 ubuntu_config="ppc64el-config.flavour.generic"
596 ;;
597
598 *)
599 echo "Unsupported arch $arch"
600 exit 1
601 ;;
602 esac
603else
04873cc3 604 echo "No arch or cross_arch specified"
7e02032c
MJ
605 exit 1
606fi
339db64d 607
339db64d 608
b214d997 609
5a196804
MJ
610# First get the kernel build from the object store, or build it, if it's
611# not available.
339db64d 612
5a196804
MJ
613echo "# Setup endpoint
614host_base = obj.internal.efficios.com
615host_bucket = obj.internal.efficios.com
616bucket_location = us-east-1
617use_https = True
7e02032c 618
5a196804
MJ
619# Setup access keys
620access_key = jenkins
621secret_key = echo123456
339db64d 622
5a196804
MJ
623# Enable S3 v4 signature APIs
624signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 625
c45b04df 626url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 627obj_name="linux.tar.bz2"
87445931
MJ
628
629if [ "x${cross_arch}" = "x" ]; then
630 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/native"
631else
632 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/${cross_arch}"
633fi
634
5a196804 635obj_url="$obj_url_prefix/$obj_name"
339db64d 636
5a196804
MJ
637set +e
638s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
639ret=$?
640set -e
339db64d 641
5a196804
MJ
642case "$ret" in
643 "0")
644 extract_archive_obj
645 ;;
a1ae361e 646
5a196804
MJ
647 "12")
648 echo "File not found"
339db64d 649
5a196804
MJ
650 # Build all the things and upload
651 # then finish the module build...
339db64d 652
5a196804
MJ
653 git_clone_linux_sources
654 git_export_linux_sources
339db64d 655
5a196804 656 select_compiler
a1ae361e 657
5a196804
MJ
658 ## PREPARE FULL LINUX SOURCE TREE
659 build_linux_kernel
d138fc44 660
5a196804
MJ
661 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
662 extract_distro_headers
339db64d 663
5a196804 664 tar_archive_obj
339db64d 665
5a196804 666 upload_archive_obj
339db64d 667
5a196804 668 ;;
339db64d 669
5a196804
MJ
670 *)
671 echo "Unknown error? Abort"
672 exit 1
673 ;;
674esac
339db64d 675
5a196804 676select_compiler
f3d8604b 677
7e02032c 678## BUILD modules
5a196804
MJ
679# Either we downloaded a pre-build kernel or we built it and uploaded
680# the archive for future builds.
681
682cd "$WORKSPACE"
f3d8604b 683
339db64d 684# Build modules against full kernel sources
5a196804 685build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 686
339db64d 687# Build modules against kernel headers
5a196804 688build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 689
5a196804
MJ
690# Make sure some modules were actually built
691tree "${MODULES_OUTPUT_KSRC_DIR}"
692if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
693 echo "No modules built!"
694 exit 1
695fi
696
5a196804
MJ
697tree "${MODULES_OUTPUT_KHDR_DIR}"
698if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
699 echo "No modules built!"
700 exit 1
701fi
b214d997 702
f3d8604b 703# EOF
This page took 0.062694 seconds and 4 git commands to generate.